/*
 * Copyright (C) Microsoft Corporation, 1982
 */

#include <stdio.h>
#include "y.tab.h"
#include "a86.h"

/* these two arrays are used to compute the r/m field for
	indexed memory references 
*/
char indxbit[8] = {
	0,0,0,8,0,2,4,1 };
char r_m[16] = {
	-1,5,6,3,4,-1,2,-1,7,1,-1,-1,0,-1,-1,-1 };

/* expression index for value of constant and length ( '*' = 8, '#' = 16 ) */
struct estak *c_value;
char c_len;

/* expression stack temporaries */
struct estak estk[20];
struct estak *e,*exp = estk;

/* memory operand stack temporaries */
struct memstk MMem[2],*m,*mem = MMem;
struct memstk *mem_com();

/* miscellaneous variables & temporaries */
int word,ilen;
int reg,i;
unsigned Text = 0; /* size of text segment */
unsigned Data = 0; /* size of data segment */
unsigned Bss = 0; /* size of bss segment */
unsigned Entry = 0; /* start location for program */
unsigned new_dot = 0;
int Linenum = 1; /* current line being assembled */
int Globals = 0; /* index number for output symbol table */
char Pass; /* current pass of assembler */

/* array to save generated code for listing */
int j = 0; /* index into core array */
char core[100];

/* flags in relocation data for temp file */

/* file pointers for source input and listing */
FILE *list,*input;
FILE *inpstk[MAXINSRT]; /* stack of insert files */
int istak=0; /* index into input stack */

/* temporary work file, pseudo object code */
FILE *object;
char *objtemp = "/tmp/ASXXXXXX";

/* flags for lexical analyzer and line buffer */
char opcflg=1; /* 1 = still looking for opcode on this line */
char readflg=1; /* 1 = need to read another line */
char operflg = 1; /* 1 = octal & hex constants are valid */
char endflag = 0; /* 1 = found end statement */
char linebuf[MAXLINE];
char *lineptr;

char String[128]; /* buffer used for accumlating delimited strings */
char *strptr; /* current character of string */
char delimit; /* string delimiter character */
char strmod=0; /* 1= string scan mode */

char Listing = 0; /* 1 = produce listing on first pass */
char Ext_only = 0; /* 1 = put only .globals in text file */
char Frm_cmp = 0 ; /* compiler generated assembly */
char Und_glb = 1; /* 1 = make undefined syms into globals */
char Med_opt = 0;	/* medium model assembly */
int Errors = 0; /* number of errors */
int no_eof = 1;		/* no end of file */

					/* symbol table definitions */
struct Sym Dot = { A_TEXT, 0,0,0,0,0, "." } ;
struct Sym *gl_head,*gl_tail;		/* global symbol chain */
struct Sym *hashtab[HASHVAL] = 0;
struct Sym *lcl_tab = 0;		/* local symbols chain */

/* intel format stuff.  There is no need to conditionaly compile
   just to exclude this stuff.  it is ignored by the a.out stuff */
char *Rel_name ;
char out_lines = 0 ;
char end_out = 0 ;
char Self_rel = 0;
char Fix_it = 0;
char Rel_lng = 0;
