
/*
 * Copyright (C) Microsoft Corporation, 1982
 *
 *  vwh	Dec 17, 1982	M001
 *	modified to pass -S to the linker to produce
 *	a .sym file; and to exec the name list converter.
 *	This puts an x.out standard name list in the object file.
 *  vwh Dec 20, 1982	M002
 *	Integrated the name list converter, instead of exec'ing it.
 *	Puts XR_S86ABS symbol table in object file.
 */

#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <a.out.h>
#include <sys/relsym.h>
#include <sys/relsym86.h>

#ifdef M_WORDSWAP
#  define hostwswap 1
#else
#  define hostwswap 0
#endif

#define IDMAX (NAMELENGTH + 1)		/* 8086 symbol name length */
#define MAXINC 10
#define MAXFIL 100
#define MAXLIB 100
#define MAXOPT 100

char	*tmp0 = "/tmp/ct086XXXXXX" ;
char	*tmp1 = "/tmp/ct186XXXXXX" ;
char	*tmp2 = "/tmp/ct286XXXXXX" ;
char	*tmp3 = "/tmp/ct386XXXXXX" ;
char	*tmp4 = "/tmp/ct486XXXXXX" ;
char	*tmp5 = "/tmp/ct586XXXXXX" ;
char	*tmp6 = "/tmp/ct686XXXXXX" ;	/* for symbol conversion */
char	*outfile;			/* object file */
char	*symfile;			/* symbol file */
char	*stksize = "s0";

#define CHSPACE 1000
char	ts[CHSPACE+50];
char	*tsp = ts;
char	*av[50];
char	*clist[MAXFIL];		/* list of .c, .s files */
char	*llist[MAXLIB];		/* list of .o, library files */
int	ovrdflag;
int	pflag;
int     stflag;                 /* indicates -s, no sybol table */
int     sflag;                  /* indicates -S */
int     iflag;
int	cflag;
int	eflag;
int	Mflag;
int	aeflag;
int	alflag;
int	exflag;
int	oflag;
int     proflag;
char	*chpass ;
char	*npassname ;

#ifdef CROSS
char    passp[80] =   "/usr/8lib/c86pp";
char    pass0[80] =   "/usr/8lib/c86.0";
char    pass1[80] =   "/usr/8lib/c87.1";
char    pass2[80] =   "/usr/8lib/c86.2";
char    passasm[80] = "/usr/bin/Ia87";
char    passld[80] =  "/usr/bin/Ild86";
char    *pref =       "/usr/8lib/Scrt0.b";
char    *libpreamble= "/usr/8lib/Slib";
#define PREAMBLEN      14
#  define SUFFIX "b"

#else

char    passp[80] =   "/lib/cpp";
char    pass0[80] =   "/lib/c0";
char    pass1[80] =   "/lib/c1";
char    pass2[80] =   "/lib/c2";
char    passasm[80] = "/bin/as";
#ifdef ON86
char    passld[80] =  "/bin/ld.286";
#else
char    passld[80] =  "/bin/ld";
#endif
char    *pref = "/lib/Scrt0.o";
char    *libpreamble= "/lib/Slib";
#define PREAMBLEN      9
#  define SUFFIX "o"
#endif

char	*mapfile;
char	*prog;			/* argv[0] */

char	*setsuf();
char	*strcat();
char	*strcpy();
char	*mktemp();
char	*malloc();

struct xexec shdr, ohdr;	/* symbol & object file headers */
FILE	*tfp;			/* temp file */
FILE	*sfp, *ofp;
long	ssyms, osyms;

main(argc, argv)
char *argv[]; 
{
	char *t;
	char *savetsp;
	char *assource;
	char **pv, *ptemp[MAXOPT], **pvt;
	int nc, nl, i, j,  nxo, na;
	int idexit();

	prog = argv[0];
	i = nc = nl =  nxo = 0;
	setbuf(stdout, (char *)NULL);
	pv = ptemp;
	while(++i < argc) {
		if(*argv[i] == '-') switch (argv[i][1]) {
		default:
			goto passa;
		case 'n':
			argv[i][1] = 'i';               /* -n ==> -i */
		case 'i':
			iflag++;
			goto passa;
		case 'S':
			sflag++;    /* save generated assembler code */
			cflag++;
			break;
		case 'o':		/* rename output */
			if (++i < argc) {
				outfile = argv[i];
				if(getsuf(outfile,"c") && !ovrdflag){
					error("Would overwrite %s", outfile);
					exit(8);
				}
			}
			break;
		case 'M':
			Mflag = 1;
			iflag++;
#ifdef CROSS
			strcpy(pass0,  "/usr/8lib/Ic86.0");
			strcpy(pass1,  "/usr/8lib/Ic87.1");
			strcpy(pass2,  "/usr/8lib/Ic86.2");
			pref =       "/usr/8lib/Icrt0.87.b";
			libpreamble = "/usr/8lib/Mlib";
#else
			strcpy(pass0,  "/lib/Mc0");
			strcpy(pass1,  "/lib/Mc1");
			strcpy(pass2,  "/lib/Mc2");
			pref = "/lib/Mcrt0.o";
			libpreamble = "/lib/Mlib";
#endif
			break;

		case 'm':
			if (++i < argc) {
				mapfile = argv[i];
				if(getsuf(mapfile,"c") && !ovrdflag){
					error("Would overwrite %s", mapfile);
					exit(8);
				}
			}
			break;
		case '!':		/* override clobber protection */
			ovrdflag++;
			break;
		case 'O':		/* optimize the output assembly */
			oflag++;
			break;
		case 's':		/* no symbol table */
			stflag++;
			break;
		case 'p':
			proflag++;
			break;
		case 'E':
			exflag++;
		case 'P':
			pflag++;	/* save preprocessor output */
			*pv++ = argv[i];
		case 'c':
			cflag++;	/* don't try to link */
			break;
		case 'L':		/* generate assembly listing */
			alflag++ ;
			break;
		case 'e':		/* externals only in symbol table */
			aeflag++ ;
			break;
		case 'D':		/* define */
		case 'I':		/* include */
		case 'U':		/* undefine */
		case 'C':
			*pv++ = argv[i];
			if (pv >= ptemp+MAXOPT) {
				error("Too many DIUC options", (char *)NULL);
				--pv;
			}
			break;
		case 'f':
			break;
		case 't':		/* use test version for given passes */
			if (chpass)
				error("-t overwrites earlier option", (char *)NULL);
			chpass = argv[i]+2;
			if (chpass[0]==0)
				chpass = "012pa";
			break;

		case 'B':
			if (npassname)	/* new name for overide passes */
				error("-B overwrites earlier option", (char *)NULL);
			npassname = argv[i]+2;
			if (npassname[0]==0)
				npassname = "/usr/oldc86/";
			break;
		/* but, we will use the old variable for a similar purpose
		   pass the code generator the stack warning path size
		   by turning '-K0000' into 's0000'.
		 	-Hans, Mar 4, 1982 */
		case 'K':
			stksize = argv[i];
			*++stksize = 's';
			break;

		case 'l':
			/* the linker needs us to spell these out as
			 *      -l /lib/[SM]lib<name>.a      */
			t = malloc(PREAMBLEN + (strlen(argv[i]) -2) +3);
			llist[nl++] = "-l";
			llist[nl++] = t;
			strcpy(t, libpreamble);         /* /lib/[SM]lib */
			t += PREAMBLEN;
			strcpy(t, &argv[i][2]);
			t += strlen(argv[i]) - 2;
			*t++ = '.';
			*t++ = 'a';
			*t   = '\0';
			break;
		} 
		else {
passa:
			t = argv[i];
			if(getsuf(t, "c") ||getsuf(t,"s") || exflag) {
				clist[nc++] = t;
				if (nc>=MAXFIL) {
					error("Too many source files", (char *)NULL);
					exit(1);
				}
				t = setsuf(t, SUFFIX);
			}
			if (nodup(llist, t)) {
				if (getsuf(t, "a"))
					llist[nl++] = "-l";
				llist[nl++] = t;
				if (nl >= MAXLIB) {
					error("Too many object/library files", (char *)NULL);
					exit(1);
				}
				if (getsuf(t, SUFFIX))
					nxo++;
			}
		}
	}
	if (npassname && chpass ==0)
		chpass = "012pal";
	if (chpass && npassname==0)
		npassname = "/usr/newc86/";
	if (chpass)
		for (t=chpass; *t; t++) {
			switch (*t) {
#ifdef CROSS
			case 'p':
				strcpy (passp, npassname);
				strcat (passp, "c86pp");
				continue;
			case '0':
				strcpy (pass0, npassname);
				if(!Mflag)
				strcat (pass0, "c86.0");
				else
				strcat (pass0, "Ic86.0");
				continue;
			case '1':
				strcpy (pass1, npassname);
				if(!Mflag)
				strcat (pass1, "c87.1");
				else
				strcat (pass1, "Ic87.1");
				continue;
			case '2':
				strcpy (pass2, npassname);
				if(!Mflag)
				strcat (pass2, "c86.2");
				else
				strcat (pass2, "Ic86.2");
				continue;
			case 'a':
				strcpy (passasm, npassname);
				strcat (passasm, "Ia87");
				continue;
			case 'l':
				strcpy (passld, npassname);
				strcat (passld, "Ild86");
				continue;
#else
			case 'p':
				strcpy (passp, npassname);
				strcat (passp, "cpp");
				continue;
			case '0':
				strcpy (pass0, npassname);
				if(!Mflag)
				strcat (pass0, "c0");
				else
				strcat (pass0, "Mc0");
				continue;
			case '1':
				strcpy (pass1, npassname);
				if(!Mflag)
				strcat (pass1, "c1.87");
				else
				strcat (pass1, "Mc1.87");
				continue;
			case '2':
				strcpy (pass2, npassname);
				if(!Mflag)
				strcat (pass2, "c2");
				else
				strcat (pass2, "Mc2");
				continue;
			case 'a':
				strcpy (passasm, npassname);
				strcat (passasm, "Mas.87");
				continue;
			case 'l':
				strcpy (passld, npassname);
				strcat (passld, "ld");
				continue;
#endif
			}
		}
	if (proflag)
		{
#ifdef CROSS
		if(!Mflag)
			pref = "/usr/8lib/Smcrt0.b";
		else
			pref = "/usr/8lib/Imcrt0.b";
#else
		if(!Mflag)
			pref = "/lib/Smcrt0.o";
		else {
			fprintf(stderr, "-p not supported with -M\n");
			exit(1);
		}
#endif
		}
	if(nc==0)
		goto nocom;
	if (pflag==0) {
		tmp0 = mktemp(tmp0) ;
		if (creat(tmp0, 0400)<0) {
			error("cc: cannot create temp", (char *) NULL);
			exit(1);
		}
	}
	if (signal(SIGINT, SIG_IGN) != SIG_IGN)
		signal(SIGINT, idexit);
	if (signal(SIGTERM, SIG_IGN) != SIG_IGN)
		signal(SIGTERM, idexit);
	tmp1 = mktemp(tmp1) ;
	tmp2 = mktemp(tmp2) ;
	tmp3 = mktemp(tmp3) ;
	if (oflag)
		tmp5 = mktemp(tmp5) ;
	if (pflag==0)
		tmp4 = mktemp(tmp4) ;
	pvt = pv;
	for (i=0; i<nc; i++) {
		if (nc>1)
			printf("%s:\n", clist[i]);
		if (getsuf(clist[i], "s")) {
			assource = clist[i];
			goto assemble;
		} 
		else
			assource = tmp3;
		if (pflag)
			tmp4 = setsuf(clist[i], "i");
		savetsp = tsp;
		av[0] = "cpp";
		av[1] = "-DI8086";
		na = 2;
		av[na++] = clist[i];
		av[na++] = exflag ? "-" : tmp4;
		for(pv=ptemp; pv <pvt; pv++)
			av[na++] = *pv;
#ifndef I8086
		av[na++] = "-I/usr/include/8086";
#endif
		av[na++]=0;
		if (callsys(passp, av)) {
			cflag++;
			eflag++;
			continue;
		}
		av[1] = tmp4;
		tsp = savetsp;
#ifdef CROSS
		if(!Mflag)
			av[0]= "c86.0";
		else
			av[0]= "Ic86.0";
#else
		if(!Mflag)
			av[0]= "c0";
		else
			av[0]= "Mc0";
#endif
		if (pflag) {
			cflag++;
			continue;
		}
		av[2] = tmp1;
		av[3] = tmp2;
		if (proflag) {
			av[4] = "-p";
			av[5] = 0;
		} 
		else
			av[4] = 0;
		if (callsys(pass0, av)) {
			cflag++;
			eflag++;
			continue;
		}
#ifdef CROSS
		if(!Mflag)
			av[0]= "c87.1";
		else
			av[0]= "Ic87.1";
#else
		if(!Mflag)
			av[0]= "c1";
		else
			av[0]= "Mc1";
#endif
		av[1] = tmp1;
		av[2] = tmp2;
		if (sflag)
			assource = tmp3 = setsuf(clist[i], "s");
		av[3] = tmp3;
		if (oflag)
			av[3] = tmp5;
		av[4] = stksize;
		av[5] = 0;
		if(callsys(pass1, av)) {
			cflag++;
			eflag++;
			continue;
		}
		if (oflag) {
#ifdef CROSS
			if(!Mflag)
				av[0]= "c86.2";
			else
				av[0]= "Ic86.2";
#else
			if(!Mflag)
				av[0]= "c2";
			else
				av[0]= "Mc2";
#endif
			av[1] = tmp5;
			av[2] = tmp3;
			av[3] = 0;
			if (callsys(pass2, av)) {
				unlink(tmp3);
				tmp3 = assource = tmp5;
			} 
			else
				unlink(tmp5);
		}
		if (sflag)
			continue;
assemble:
#ifdef CROSS
			av[0] = "Ia87";
#else
			av[0] = "as";
#endif
		if(alflag && aeflag)
			av[1] = "-gCle";
		else if (alflag)
			av[1] = "-gCl" ;
		else if (aeflag)
			av[1] = "-gCe" ;
		else
			av[1] = "-gC" ;
		av[2] = "-o";
		if (nc == 1 && cflag && outfile) {
			av[3] = outfile;
		} else 
			av[3] = setsuf(clist[i], SUFFIX);
		if(Mflag)
			{
			av[4] = "-M";
			av[5] = assource;
			av[6] = 0;
			}
		else
			{
			av[4] = assource;
			av[5] = 0;
			}
		cunlink(tmp1);
		cunlink(tmp2);
		cunlink(tmp4);
		if (callsys(passasm, av) > 1) {
			cflag++;
			eflag++;
			continue;
		}
	}
nocom:
	if (cflag==0 && nl!=0) {
		i = 0;
#ifdef CROSS
		av[0] = "Ild86";
		av[1] = pref;
		j = 2;
#else
		av[0] = "ld";
		j = 1;
		if (!iflag)
			av[j++] = "/lib/segimp.o";
		else
			av[j++] = "/lib/seg.o";
		av[j++] = pref;
#endif
		av[j++] = "-C";
		if (!stflag) {
			av[j++] = "-S";		/* M001 */
		}
		if (Mflag)
			av[j++] = "-M";
		if (outfile == NULL)
			outfile = "a.out";
		av[j++] = "-o";
		av[j++] = outfile;
		if (mapfile) {
			av[j++] = "-m";
			av[j++] = mapfile;
		}
		while(i<nl)
			av[j++] = llist[i++];
#ifdef CROSS
#else
		av[j++] = "-l";
		if(!Mflag) {
			av[j++] = "/lib/Slibcfp.a";
			av[j++] = "-l";
			av[j++] = "/lib/Slibc.a";
		} else {
			av[j++] = "/lib/Mlibcfp.a";
			av[j++] = "-l";
			av[j++] = "/lib/Mlibc.a";
		}
#endif
		av[j++] = 0;
#ifdef PLBDEBUG
printf("link pass: %s ", passld);
j=0;
while(av[j]) printf("%s ",av[j++]);
printf("\n");
#endif
		eflag |= callsys(passld, av);
		if (nc==1 && nxo==1 && eflag==0)
			cunlink(setsuf(clist[0], SUFFIX));
		if ((stflag | eflag) == 0) {
			/* nlcv() */;
		}
	}
	dexit();
}




/*
 *	nlcv - convert linker symbols to XR_S86ABS,
 *		and insert in output file.
 */

nlcv()
{
	int rpad, orpad;
	int i;
	long orpos;

	symfile = malloc((unsigned) strlen(outfile) + 5);
	if (symfile == NULL) {
		error("out of memory", (char *) NULL);
		dexit();
	}
	strcpy(symfile, outfile);
	strcat(symfile, ".sym");
	tmp6 = mktemp(tmp6);
	if ((sfp = fopen(symfile, "r")) == NULL) {
		error("can't open %s", symfile);
		dexit();
	}
	if (fread((char *) &shdr, sizeof(shdr), 1, sfp) != 1) {
		error("%s: can't read header", symfile);
		dexit();
	}
	if ((shdr.x_syms == 0) && (shdr.x_reloc)) {
		/* is a buggy version of linker, we're easy */
		shdr.x_syms = (shdr.x_reloc>>16) & 0xffff;
		shdr.x_reloc = 0;
	}
	ssyms = shdr.x_syms;
	if ((ofp = fopen(outfile, "r")) == NULL) {
		error("can't open %s", outfile);
		dexit();
	}
	if (fread((char *) &ohdr, sizeof(ohdr), 1, ofp) != 1) {
		error("%s: can't read header", outfile);
		dexit();
	}
	if ((ohdr.x_magic != X_MAGIC) || ohdr.x_ext) {
		error("%s: bad object file format", outfile);
		dexit();
	}
	if ((tfp = fopen(tmp6, "w")) == NULL) {
		error("can't create temp file", (char *) NULL);
		dexit();
	}
	copy(ofp, tfp, ohdr.x_text + ohdr.x_data);

	nlcv1();		/* convert and write symbols */

	orpos = XRELPOS(&ohdr);
	ohdr.x_syms = osyms;	    /* set symbol table size & type */
	ohdr.x_relsym = (ohdr.x_relsym & XR_REL) | XR_S86ABS;
	if (ohdr.x_reloc) {
		if (rpad = (XRELPOS(&ohdr) % sizeof(struct srel86))) {
			rpad = sizeof(struct srel86) - rpad;
		}
		for (i = 0; i < rpad; i++) {
			putc('\0', tfp);
		}
		orpad = ohdr.x_reloc % sizeof(struct srel86);
		fseek(ofp, orpos + orpad, 0);
		copy(ofp, tfp, ohdr.x_reloc - orpad);
		ohdr.x_reloc += rpad - orpad;
	}
	fclose(sfp);
	fclose(ofp);
	fclose(tfp);
	if ((ofp = fopen(outfile, "w")) == NULL) {
		error("can't reopen %s", outfile);
		dexit();
	}
	if ((tfp = fopen(tmp6, "r")) == NULL) {
		error("can't reopen temp file", (char *) NULL);
		dexit();
	}
	fwrite((char *) &ohdr, sizeof(ohdr), 1, ofp);
	copy(tfp, ofp, XENDPOS(&ohdr) - (long) sizeof(ohdr));
	fclose(ofp);
	fclose(tfp);
}




nlcv1()
{
	unsigned int seg, off, type;
	int nlen, n;
	struct sym sym;
	char nbuf[IDMAX];

	osyms = 0L;
	sym.s_pad = 0;
	while (ssyms) {
		seg = readint();	/* read segment */
		off = readint();	/* read offset */
		type = getch();		/* read symbol type */
		nlen = getch();		/* symbol name length */
		if (nlen >= IDMAX) {
			error("%s: symbol name too long", symfile);
			dexit();
		}
		n = fread(nbuf, sizeof(char), nlen, sfp);
		if (n != nlen) {
			error("%s: read error", symfile);
			dexit();
		}
		nbuf[nlen] = '\0';
		ssyms -= 6 + nlen;

		switch (type & 0x03) {
		case 0x00:  sym.s_type = S_BSS | S_EXTERN; break;
		case 0x01:
		case 0x03:  sym.s_type = S_TEXT | S_EXTERN; break;
		case 0x02:  sym.s_type = S_DATA | S_EXTERN; break;
		}
		sym.s_value = ((long) seg << 16) + off;
		fwrite((char *) &sym, sizeof(sym), 1, tfp);
		fwrite(nbuf, sizeof(char), nlen + 1, tfp);
		osyms += sizeof(sym) + nlen + 1;
	}
}




readint()
{
	register int first;

	first = getch();
	return(first | (getch() << 8));
}




getch()
{
	register int c;
	if ((c = getc(sfp)) == EOF) {
		error("%s: premature end of file", symfile);
		dexit();
	}
	return(c);
}




copy(sf, df, size)
FILE *sf;		/* source file */
FILE *df;		/* destination file */
long size;
{
	register int s;
	char buf[512];

	while (size != 0) {
		s = (size < 512)? (int) size : 512;
		if (fread(buf, s, 1, sf) != 1) {
			error("copy: bad read", (char *) NULL);
			dexit();
		}
		if (fwrite(buf, s, 1, df) != 1) {
			error("copy: bad write", (char *) NULL);
			dexit();
		}
		size -= s;
	}
}




idexit()
{
	eflag = 100;
	dexit();
}




dexit()
{
	if (!pflag) {
		cunlink(tmp1);
		cunlink(tmp2);
		if (sflag==0)
			cunlink(tmp3);
		cunlink(tmp4);
		cunlink(tmp5);
		cunlink(tmp0);
		cunlink(tmp6);
		cunlink(symfile);	/* M001 */
	}
	exit(eflag);
}





error(s, x)
char *s, *x;
{
	fprintf(exflag? stderr : stdout, "%s: ", prog);
	fprintf(exflag? stderr : stdout, s, x);
	putc('\n', exflag? stderr : stdout);
	cflag++;
	eflag++;
}




getsuf(as, pat)
char as[];
char *pat;
{
	register int c;
	register char *s;
	register int t;

	s = as;
	c = 0;
	while(t = *s++)
		if (t=='/')
			c = 0;
		else
			c++;
	s -= strlen(pat) + 2;
	if (c<=14 && c>strlen(pat) && *s++=='.')
		return(strcmp(s, pat) == 0);
	return(0);
}




char *
setsuf(as, st)
char *as, *st;
{
	register char *s, *s1;

	s = s1 = malloc((unsigned) strlen(as) + 1) ;
	if(s1 == NULL)
		{
		error("no space for file names", (char *)NULL) ;
		dexit() ;
		}
	strcpy(s1,as) ;
	while(*s)
		if (*s++ == '/')
			s1 = s;
	while (*s != '.')
		s--;
	strcpy(s+1, st);
	return(s1);
}




callsys(f, v)
char f[], *v[]; 
{
	register int t;
	int status;

#ifdef DEBUG
	char **p;
	printf ("c86: calling :%s:\n", &f[0] );
	t = 0;
	for (p=v; *p != (char *)0; p++)
		printf ("  arg %d is :%s:\n", t++, *p);
#endif

	if ((t=fork())==0) {
		execv(f, v);
		printf("Can't find %s\n", f);
		exit(100);
	} else
		if (t == -1) {
			printf("Try again\n");
			return(100);
		}
	while(t!=wait(&status))
		;
	if (t = status&0377) {
		if (t!=SIGINT) {
			printf("Fatal error in %s\n", f);
			eflag = 8;
		}
		dexit();
	}
	return((status>>8) & 0377);
}




nodup(l, os)
char **l, *os;
{
	register char *t, *s;
	register int c;

	s = os;
	if (getsuf(s, SUFFIX))
		return(1);
	while(t = *l++) {
		while(c = *s++)
			if (c != *t++)
				break;
		if (*t=='\0' && c=='\0')
			return(0);
		s = os;
	}
	return(1);
}




cunlink(f)
char *f;
{
	if (f==NULL)
		return;
	unlink(f);
}


