/* bndmi.h
*  8086 machine instruction constant definitions
*  Peter Stewart
*  February 12, 1983
*  Translated from the original PL/M version (bndmi.idf)
*/
#define RETNEAR                 0x0C3   /* Op code for short return */
#define RETFAR                  0x0CB   /* Op code for long return */
#define RETPOPNEAR              0x0C2   /* Op code for short return w/ pop */
#define RETPOPFAR               0x0CA   /* Op code for long return w/ pop */
#define CLI                     0x0FA   /* Op code for cli instruction */
#define PUSHCX                  0x51    /* Op code for push cx */
#define PUSHBP                  0x55    /* Op code for push bp */
#define PUSHSI                  0x56    /* Op code for push si */
/* Op code prefix for two-operand instructions with immediate mode 16-bit
*  source operand and register or memory 16-bit destination operand
*/
#define ARITHIMMED              0x81
#define ARITHWORDIMMED          0x81
/* Op code prefix for two-operand instructions with immediate mode 8-bit
*  source operand and register or memory 16-bit destination operand
*/
#define ARITHBYTEIMMED          0x83
#define MODSUBTRACTSP           0x0EC
#define JMPDIRECTFAR            0x0EA   /* Op code for jump far */
#define MASKWORDMI              0x0FD
#define CALLDIRECTFAR           0x09A   /* Op code for long call */
#define CALL1INDIRECTFAR        0x0FF
#define CALL2INDIRECTFAR        0x1E
#define NOP                     0x90    /* Op code for no-op */
#define BREAKPOINT              0x0CC   /* Op code for interrupt 3 (brkpt) */
