    /****************************************************************
    *                                                               *
    *                   LINKER COMPILATION CONSTANTS                *
    *                                                               *
    ****************************************************************/

#define TRUE            (~0)            /* Necessary for Lattice C */
#define FALSE           0               /* Normal FALSE value */

/* Part I:
*  Debugging
*/
#define DEBUG           FALSE           /* Debugging off */
#define ASSRTON         FALSE           /* Asserts on regardless of DEBUG */
#define PROFILE         FALSE           /* Do not generate profile */
#define PERFORMANCE     FALSE           /* Profile VM performance */

/* Part II:
*  Compiler
*/
#define CDEC20          FALSE           /* DEC20 version */
#define CLATTICE        FALSE           /* Not Lattice C version */
#define CXENIX          TRUE            /* XENIX C compiler */
#define COTHER          FALSE           /* Other C compiler */

/* Part III:
*  Output format
*/
#define OEXE            FALSE           /* .exe output */
#define OXOUT           FALSE           /* x.out output */
#define OIAPX286        TRUE            /* x.out 80286 output */
#define SYMBOL          TRUE            /* Produce symbol file */
#define ENCODED         FALSE           /* Produce unencoded binaries */
#define CALLOCATION     TRUE            /* C-common allocation */

/* Part IV:
*  Linker runtime OS
*/
#define OSTOPS20        FALSE           /* DEC20 OS */
#define OSXENIX         TRUE            /* Xenix */
#define OSMSDOS         FALSE           /* MSDOS */
#define OSCPM86         FALSE           /* CPM86 */
#define OSPCDOS         FALSE           /* MSDOS for IBM */
#define VERSION2        FALSE           /* Not version 2 MSDOS */
#define FIXEDSTACK      TRUE            /* Fixed stack */

/* Part V:
*  Input library format
*/
#define LIBMSDOS        FALSE           /* MSDOS style libraries */
#define LIBXENIX        TRUE            /* XENIX style libraries */

/* Part VI:
*  Command line form
*/
#define CMDMSDOS        FALSE           /* MSDOS command line format */
#define CMDXENIX        TRUE            /* XENIX command line format */

/* Part VII:
*  OEM
*/
#define OEMINTEL        TRUE            /* Intel machine */
#define OEMOTHER        FALSE           /* Some other OEM */

/* Part VIII:
*  Runtime CPU
*/
#define CPU8086         FALSE           /* 8086 */
#define CPU286          TRUE            /* 286 */
#define CPUOTHER        FALSE           /* Some other CPU */

/* Part IX:
*  Miscellaneous
*/
#define LARGEMODEL      FALSE           /* No long pointers to data */
#define SMALLVERSION    TRUE            /* Small version */
#define LARGEVERSION    FALSE           /* Not large version */
#define IGNORECASE      FALSE           /* Ignore case of symbols */
#define IOMACROS        TRUE            /* Use macros for InByte and OutByte */
#define ODDWORDLN       FALSE           /* Word length not 16 bits */
#define CRLF            FALSE           /* Newline: ^M^J or ^J */
#define SIGNEDBYTE      TRUE            /* Bytes are signed */
#define BASCOMVER       FALSE           /* Extra publics for BASCOM */
