    /****************************************************************
    *                                                               *
    *                             NEWDAT.C                          *
    *                                                               *
    ****************************************************************/

#include                "minlit.h"      /* Types and constants */
#include                "bndtrn.h"      /* More of same */
#include                "bndmi.h"       /* Machine instruction op codes */
#include                "bndvrt.h"      /* Virtual memory stuff */
#include                "lnkio.h"       /* Linker I/O definitions */

extern                  Fatal();        /* Fatal error routine */
extern                  ErrHlt();       /* Internal failure routine */
extern                  RelocErr();     /* Error message routine */
extern BYTE             Gets();         /* Get a byte of input */
extern WORD             WGets();        /* Get a word of input */
extern WORD             GetIndex();     /* Get var. length index from input */
extern                  GetBytes();     /* Read some bytes */

extern WORD             cbRec;          /* Size of current record */
extern RECTTYPE         rect;           /* Type of current record */
extern FTYPE         	vfPass1;        /* True if pass 1 */
extern RATYPE           vraCur;         /* Current segment offset */
extern RECTTYPE         vrectData;      /* Type of data record */
extern SNTYPE           vgsnCur;        /* Current global SEGDEF number */
extern SEGTYPE          vsegCur;        /* Current global segment number */
extern WORD             vcbData;        /* Count of bytes of data */
extern SEGTYPE          mpgsnseg[];     /* Map glob. SEGDEF to seg. no. */
extern RATYPE           mpgsndra[];
extern SEGTYPE          segLast;
extern BYTE             rgmi[];         /* Data buffer */
extern WORD             snMac;          /* No. of SEGDEFs in current module */
extern SNTYPE           mpsngsn[];      /* Map module SEGDEF to global */
extern char             *ompimisegDstIdata;
					/* C'mon!  What is this shit?!! */

    /****************************************************************
    *                                                               *
    *  DataRec:                                                     *
    *                                                               *
    *  This  function  takes  no arguments.  It processes a LEDATA  *
    *  record  or  an  LIDATA  record.    It  does  not  return  a  *
    *  meaningful value.  See "8086 Object Formats EPS."            *
    *                                                               *
    ****************************************************************/

DataRec()                               /* Process a data record */
  {
    register WORD       erc;            /* Error code */
    SNTYPE              sn;             /* SEGDEF number */
    RATYPE              ra;             /* Segment offset */
    WORD                imiMac;         /* No. of data bytes in record */
    SNTYPE              gsn;            /* Global SEGDEF number */

    ENTER(DataRec);                     /* Debug info */
    sn = GetIndex(1,snMac);             /* Get segment number */
    ra = WGets();                       /* Get relative address */
    imiMac = cbRec - 1;                 /* Get no. of data bytes in rec */
    if(imiMac > 0x400) ErrHlt(0x10);    /* Check if record too large */
    GetBytes(rgmi,imiMac);              /* Fill the buffer */
    DEBUGVALUE(imiMac);                 /* Debug info */
    gsn = mpsngsn[sn];                  /* Map SEGDEF no. to global SEGDEF */
    vgsnCur = gsn;                      /* Set global */
    if(!gsn || (!vfPass1 && mpgsnseg[gsn] > segLast))
      {
	vsegCur = SEGNIL;
	vrectData = RECTNIL;
	LEAVE(DataRec,0xFFFE);          /* Debug info */
	return;                         /* Good-bye! */
      }
    vraCur = ra + mpgsndra[gsn];        /* Set current relative address??? */
    vsegCur = mpgsnseg[gsn];            /* Set current segment??? */
    vcbData = imiMac;                   /* Set count of data bytes??? */
    vrectData = rect;                   /* Set the record type??? */
    if(!vfPass1 && vrectData == '\242') /* If not pass 1 and LIDATA record */
      {
	ompimisegDstIdata = (char *) rgmi + vcbData;
	if(vcbData > 0x200)             /* If size above 512 bytes */
	  {
	    RelocErr("DUP record too big",vraCur);
					/* Error */
	  }
	Setb(0,&rgmi[vcbData],vcbData);
      }
    LEAVE(DataRec,0xFFFF);              /* Debug info */
  }
