    /****************************************************************
    *                                                               *
    *                            NEWPRI.C                           *
    *                                                               *
    ****************************************************************/

#include                "minlit.h"      /* Types and constants */
#include                "bndtrn.h"      /* Basic type & const declarations */
#include                "bndvrt.h"      /* Virtual memory stuff */
#include                "lnkio.h"       /* Linker I/O definitions */

extern                  OutError();     /* Error message routine */
extern BYTE             *ObGetVa();     /* Fetch from virtual memory */
extern                  ErrHlt();       /* ??? */
extern                  EnSyms();       /* Symbol enumerator (applies fn.) */
extern                  RecordSegmentReference();
					/* ??? */

#if OXOUT OR OIAPX286
extern FTYPE            mpsegFlags[];   /* Segment attribute flags */
#endif
extern BSTYPE           bsLst;          /* List file handle */
extern char             *vob;           /* ??? */
extern WORD             vcb;            /* ??? */
extern SEGTYPE          segLast;        /* Last segment number */
extern WORD             gsnMac;         /* ??? */
extern WORD             ggrMac;         /* ??? */
extern HTETYPE          vhte;           /* ??? hash table entry */
extern RBTYPE           vrhteCODEClass; /* ??? */
extern RBTYPE           mpgsnrprop[];   /* ??? */
extern RBTYPE           vrhte;          /* ??? */
extern FTYPE            vfMap;          /* ??? */
extern FTYPE            fScrClosed;     /* ??? */
extern SNTYPE           gsnStack;       /* ??? */
extern GRTYPE           ggrDGroup;      /* ??? */
extern SATYPE           saOrigin;       /* ??? */
extern SEGTYPE          mpgsnseg[];     /* ??? */
extern RATYPE           mpgsndra[];     /* ??? */
extern SNTYPE           mpggrgsn[];     /* ??? */
extern RDTYPE           omppubrd;       /* ??? */
extern WORD             pubMac;         /* Number of public symbols defined? */
extern FTYPE            fAddressSort;   /* FGtProc() control flag */
extern SATYPE           mpsegsa[];      /* Map seg. no. to frame number */
extern RATYPE           mpsegraFirst[]; /* Map seg. no. to starting offset */
extern WORD             mpsegcb[];      /* Map seg. no. to seg. size??? */
extern ALIGNTYPE        mpsegalign[];   /* Map seg. no. to align. type */
extern IOVTYPE          mpsegiov[];     /* Map seg. no. to overlay no. */
extern RBTYPE           mpiovrhte[];    /* ??? */
extern WORD             iovMac;         /* Current count of overlays */
extern FTYPE            fOverlays;      /* TRUE if there are overlays??? */

    /****************************************************************
    *                                                               *
    *  PrintSyms:                                                   *
    *                                                               *
    ****************************************************************/

PrintSyms(prb,irdMac)
RDTYPE                  prb;            /* Table of ??? */
WORD                    irdMac;         /* Table size??? */
  {
    AHTETYPE            *pahte;         /* ??? */
    APROPTYPE           *paprop;        /* ??? */
    APROPNAMETYPE       *papropName;    /* ??? */
    APROPSNTYPE         *papropSn;      /* ??? */
    RATYPE              ra;             /* ??? */
    SATYPE              sa;             /* ??? */
    SATYPE              saDGroup;       /* ??? */
    SNTYPE              gsn;            /* ??? */
    WORD                ird;            /* Index??? */
    SEGTYPE             seg;            /* ??? */
    SBTYPE              sbName;         /* ??? */

    ENTER(PrintSyms);                   /* Debug info */
    ird = 0;                            /* Initialize */
    while(ird < irdMac)                 /* Look through table */
      {
	paprop = (APROPTYPE *) ObGetVa(AREASYMS,prb[ird++],FALSE);
					/* ??? */
	while(paprop->a_attr != ATTRNIL)
	  {                             /* Find end of list??? */
	    paprop = (APROPTYPE *)
	      ObGetVa(AREASYMS,paprop->a_next,FALSE);
					/* Try next in list */
	  }
	pahte = (AHTETYPE *) paprop;    /* Recast pointer */
	Move(B2W(pahte->cch[0]) + 1,pahte->cch,sbName);
					/* Copy the symbol */
	paprop = (APROPTYPE *) ObGetVa(AREASYMS,pahte->rprop,FALSE);
					/* ??? */
	while(paprop->a_attr != ATTRPNM)
	  {                             /* ??? */
	    paprop = (APROPTYPE *)
	      ObGetVa(AREASYMS,paprop->a_next,FALSE);
					/* Try next in list */
	  }
	papropName = (APROPNAMETYPE *) paprop;
					/* Recast pointer */
	gsn = papropName->an_gsn;       /* ??? */
	seg = mpgsnseg[gsn];            /* ??? */
	ra = papropName->an_ra;         /* ??? */
	DEBUGVALUE(ra);                 /* Debug info */
	if(gsn)                         /* ??? */
	  {
	    sa = mpsegsa[seg];          /* ??? */
	    if(seg <= segLast)          /* ??? */
	      {
		papropSn = (APROPSNTYPE *)
		  ObGetVa(AREASYMS,mpgsnrprop[gsn],FALSE);
					/* ??? */
		if(papropSn->as_ggr == ggrDGroup)
		  {
		    saDGroup = mpsegsa[mpgsnseg[mpggrgsn[ggrDGroup]]];
					/* ??? */
		    ra = (ra + ((sa - saDGroup) << 4)) & ~(~0 << WORDLN);
					/* ??? */
		    sa = saDGroup;      /* ??? */
		  }
	      }
	  }
	else sa = 0;                    /* ??? */
	DEBUGVALUE(sa);                 /* Debug info */
	DEBUGVALUE(ra);                 /* Debug info */
	fprintf(bsLst," %04x:%04x",sa,ra);
					/* Write address */
	if(!gsn || seg > segLast) fputs("  Abs  ",bsLst);
					/* Segment type */
	else if(mpsegiov[seg] != IOVROOT) fputs("  Ovl  ",bsLst);
					/* Segment type */
	else if(fOverlays) fputs("  Res  ",bsLst);
					/* Segment type */
	else fputs("       ",bsLst);    /* No overlays */
	OutSb(bsLst,sbName);            /* Output the symbol */
	if(mpsegiov[seg] != IOVROOT && gsn && seg <= segLast)
	  {
	    pahte = (AHTETYPE *)
	      ObGetVa(AREASYMS,mpiovrhte[mpsegiov[seg]],FALSE);
					/* ??? */
	    fputs(" (",bsLst);          /* Open parens */
	    OutSb(bsLst,pahte->cch);    /* ??? */
	    OutByte(bsLst,')');         /* Close parens */
	  }
	NEWLINE(bsLst);                 /* Newline */
      }
    LEAVE(PrintSyms,0xFFFF);            /* Debug info */
  }

    /****************************************************************
    *                                                               *
    *  SavePropPublic:                                              *
    *                                                               *
    *  Shit if I know!                                              *
    *                                                               *
    ****************************************************************/

LOCAL                   SavePropPublic(pahte,prop,rhte,rprop,fNewHte)
AHTETYPE                *pahte;         /* ??? */
APROPTYPE               *prop;          /* ??? */
RBTYPE                  rhte;           /* ??? */
RBTYPE                  rprop;          /* ??? */
FTYPE                   fNewHte;        /* ??? */
  {
    ASSERT(prop->a_attr == ATTRPNM);    /* Should always be a public */
    if(fNewHte)                         /* ??? */
      {
	if(pubMac >= PUBMAX) OutError(bsLst,"Too many public symbols\n");
	else omppubrd[pubMac++] = rprop;
	DEBUGMSG("In SavePropPublic...");
	DEBUGVALUE(rprop);
      }
  }

    /****************************************************************
    *                                                               *
    *  SaveHtePublic:                                               *
    *                                                               *
    *  Beats me!                                                    *
    *                                                               *
    ****************************************************************/

LOCAL                   SaveHtePublic(pahte,prop,rhte,rprop,fNewHte)
AHTETYPE                *pahte;         /* ??? */
APROPTYPE               *prop;          /* ??? */
RBTYPE                  rhte;           /* ??? */
RBTYPE                  rprop;          /* ??? */
FTYPE                   fNewHte;        /* ??? */
  {
    ASSERT(prop->a_attr == ATTRPNM);    /* Should always be a public */
    if(pubMac >= PUBMAX) OutError(bsLst,"Too many PUBLIC symbols\n");
					/* ??? */
    else omppubrd[pubMac++] = rhte;     /* ??? */
  }

    /****************************************************************
    *                                                               *
    *  FGtProc:                                                     *
    *                                                               *
    *  This routine is  quite probably  the worst piece  of code I  *
    *  have ever seen in my life!  Its function  is to compare two  *
    *  RBTYPEs, and so  it does.  It compares them  based on their  *
    *  addresses, or  it  compares  them  lexicographically.  Just  *
    *  which  comparison  is performed depends on the setting of a  *
    *  global flag.  AUGH!!                                         *
    *                                                               *
    ****************************************************************/

LOCAL FTYPE             FGtProc(rb1,rb2)
RBTYPE                  rb1;            /* ??? */
RBTYPE                  rb2;            /* ??? */
  {
    APROPNAMETYPE       *paprop1;       /* ??? */
    APROPNAMETYPE       *paprop2;       /* ??? */
    AHTETYPE            *pahte1;        /* ??? */
    AHTETYPE            *pahte2;        /* ??? */
    SEGTYPE             seg1;           /* ??? */
    SEGTYPE             seg2;           /* ??? */
    WORD                sa1;            /* ??? */
    WORD                sa2;            /* ??? */
    long                ibMem1;         /* ??? */
    long                ibMem2;         /* ??? */

    paprop1 = (APROPNAMETYPE *) ObGetVa(AREASYMS,rb1,FALSE);
					/* Fetch from VM */
    paprop2 = (APROPNAMETYPE *) ObGetVa(AREASYMS,rb2,FALSE);
					/* Fetch from VM */
    if(fAddressSort)                    /* ??? */
      {
	seg1 = mpgsnseg[paprop1->an_gsn];
					/* ??? */
	seg2 = mpgsnseg[paprop2->an_gsn];
					/* ??? */
#if OXOUT OR OIAPX286
	if(mpsegFlags[seg1] & FCODE == FCODE &&
	  !(mpsegFlags[seg2] & FCODE)) return(FALSE);
					/* ??? */
	if(mpsegFlags[seg2] & FCODE == FCODE &&
	  !(mpsegFlags[seg1] & FCODE)) return(TRUE);
					/* ??? */
#endif
	if(mpsegiov[seg1] > mpsegiov[seg2]) return(TRUE);
					/* ??? */
	if(mpsegiov[seg2] > mpsegiov[seg1]) return(FALSE);
					/* ??? */
	sa1 = mpsegsa[seg1];            /* Get frame number */
	sa2 = mpsegsa[seg2];            /* Get frame number */
	ibMem1 = (long)(sa1 << 4) + paprop1->an_ra;
					/* Make 20-bit absolute address */
	ibMem2 = (long)(sa2 << 4) + paprop2->an_ra;
					/* Make 20-bit absolute address */
	if(ibMem1 > ibMem2) return(TRUE);
					/* If first greater, return true */
	if(sa1 > sa2) return(TRUE);     /* If first's frame greater, true */
	return(FALSE);                  /* False */
      }
    pahte1 = (AHTETYPE *) paprop1;      /* ??? */
    pahte2 = (AHTETYPE *) paprop2;      /* ??? */
    if(SbCompare(pahte1->cch,pahte2->cch,1) > 0) return(TRUE);
    return(FALSE);
  }

    /****************************************************************
    *                                                               *
    *  Sort:                                                        *
    *                                                               *
    ****************************************************************/

LOCAL                   Sort(prb,irdMac)
RDTYPE                  prb;            /* Table of RBTYPEs */
WORD                    irdMac;         /* Table size??? */
  {
    int                 irdFirst;
    int                 irdLast;
    int                 irdTop;
    int                 irdBot;
    int                 ird1;
    int                 ird2;
    int                 irdMedian;
    RBTYPE              rdTemp;
    RBTYPE              rdPivot;
    int                 mppartFirstird[PARTMAX];
    int                 mppartLastird[PARTMAX];
    int                 partMac;

    ENTER(Sort);                        /* Debug info */
    irdFirst = 0;                       /* Initialize index */
    irdLast = irdMac - 1;               /* Initialize index */
    partMac = 0;                        /* Initialize counter */
    for(;;)                             /* Loop to do the sort */
      {
	while(irdLast - irdFirst < 6)
	  {
	    if(!irdFirst && irdLast) break;
					/* If near the beginning, break */
	    ird1 = irdFirst + 1;
	    while(ird1 <= irdLast)
	      {
		ird2 = ird1 - 1;
		rdPivot = prb[ird1++];
		ASSERT(rdPivot >= 0 && rdPivot < 65535);
		while(FGtProc(prb[ird2],rdPivot))
		  {
		    prb[ird2 + 1] = prb[ird2];
		    --ird2;
		  }
		prb[ird2 + 1] = rdPivot;
	      }
	    DEBUGVALUE(partMac);        /* Debug info */
	    if(!partMac--) return;
	    irdFirst = mppartFirstird[partMac];
	    irdLast = mppartLastird[partMac];
	  }
	irdMedian = (irdFirst + irdLast) >> 1;
	rdPivot = prb[irdMedian];
	irdTop = irdFirst;
	irdBot = irdLast;
	ASSERT(rdPivot >= 0 && rdPivot < 0xFFFF);
	if(FGtProc(prb[irdLast],rdPivot))
	  {
	    prb[irdMedian] = prb[irdLast];
	    prb[irdLast] = rdPivot;
	    rdPivot = prb[irdMedian];
	  }
	ASSERT(prb[irdFirst] >= 0 && prb[irdFirst] < 65535);
	if(FGtProc(rdPivot,prb[irdFirst]))
	  {
	    prb[irdMedian] = prb[irdFirst];
	    prb[irdFirst] = rdPivot;
	    rdPivot = prb[irdMedian];
	    ASSERT(rdPivot >= 0 && rdPivot < 0177777);
	    if(FGtProc(prb[irdLast],rdPivot))
	      {
		prb[irdMedian] = prb[irdLast];
		prb[irdLast] = rdPivot;
		rdPivot = prb[irdMedian];
	      }
	  }
	rdTemp = prb[irdBot];
	while(irdTop <= irdBot)
	  {
	    prb[irdBot] = prb[irdTop];
	    prb[irdTop] = rdTemp;
	    ASSERT(rdPivot >= 0 && rdPivot < 65535 + 0);
	    while(FGtProc(prb[--irdBot],rdPivot))
	      {
		if(!irdBot) break;      /* Do not underflow table */
	      }
	    rdTemp = prb[irdBot];
	    ASSERT(prb[irdTop + 1] >= 0 && prb[irdTop + 1] < 65535);
	    while(FGtProc(rdPivot,prb[++irdTop]))
	      {
		if(irdTop >= irdMac - 1) break;
					/* Do not overflow table */
	      }
	  }
	if(irdBot - irdFirst < irdLast - irdTop)
	  {
	    mppartFirstird[partMac] = irdTop;
	    mppartLastird[partMac] = irdLast;
	    irdLast = irdBot;
	  }
	else
	  {
	    mppartFirstird[partMac] = irdFirst;
	    mppartLastird[partMac] = irdBot;
	    irdFirst = irdTop;
	  }
	if(++partMac >= PARTMAX) ErrHlt(0x70);
					/* Increment counter */
      }
  }

    /****************************************************************
    *                                                               *
    *  PrintGroupOrigins:                                           *
    *                                                               *
    ****************************************************************/

PrintGroupOrigins(hte,papropGroup,rhte,rprop,fNewHte)
AHTETYPE                *hte;
APROPGROUPTYPE          *papropGroup;
HTETYPE                 rhte;
RBTYPE                  rprop;
FTYPE                   fNewHte;
  {
    if(mpggrgsn[papropGroup->ag_ggr] != GRNIL)
      {
	fprintf(bsLst," %04x:0   ",
	  mpsegsa[mpgsnseg[mpggrgsn[papropGroup->ag_ggr]]]);
					/* Write the group base */
	OutSb(bsLst,hte->cch);          /* Output name */
	NEWLINE(bsLst);                 /* Newline */
      }
  }

    /****************************************************************
    *                                                               *
    *  PrintMap:                                                    *
    *                                                               *
    ****************************************************************/

PrintMap()
  {
    SEGTYPE             seg;
    WORD                cch;
    APROPSNTYPE         *papropSn;
    APROPTYPE           *paprop = (APROPTYPE *) vob;
    AHTETYPE            *pahte = (AHTETYPE *) vob;
    SNTYPE              gsn;
    RBTYPE              mppubrd[PUBMAX];
    long                addrStart;
    long                addr;
    WORD                cb;
    IOVTYPE             iov;

    ENTER(PrintMap);                    /* Debug info */
    NEWLINE(bsLst);                     /* Skip a line */
    fputs(" Start  Stop   Length Name                   Class",bsLst);
					/* Write header */
    NEWLINE(bsLst);                     /* Newline */
    for(iov = 0; iov < iovMac; ++iov)   /* Loop to print map entries */
      {
	if(fOverlays)                   /* If there are overlays */
	  {
	    if(iov == IOVROOT)          /* If this is initial overlay */
	      {
		fputs(" Resident",bsLst);
					/* Message */
	      }
	    else                        /* Else if initially non-resident */
	      {
		fputs(" Overlay ",bsLst);
					/* Message */
		vob = ObGetVa(AREASYMS,mpiovrhte[iov],FALSE);
		pahte = (AHTETYPE *) vob;
					/* Recast pointer */
		OutSb(bsLst,pahte->cch);/* Output overlay name */
	      }
	    NEWLINE(bsLst);             /* Newline */
	  }
	for(seg = 1; seg <= segLast; ++seg)
	  {                             /* Look at all segments */
	    if(mpsegiov[seg] == iov)    /* If member of this overlay */
	      {
		addrStart = (long) mpsegsa[seg] << 4;
					/* Get segment portion of abs addr */
		for(gsn = 1; gsn < gsnMac; ++gsn)
		  {
		    if(mpgsnseg[gsn] == seg)
		      {
			papropSn = (APROPSNTYPE *)
			  ObGetVa(AREASYMS,mpgsnrprop[gsn],FALSE);
			vob = (BYTE *) papropSn;
					/* Save address */
			paprop = (APROPTYPE *) vob;
					/* Overlay struct */
			while(paprop->a_attr != ATTRNIL)
			  {
			    vob = ObGetVa(AREASYMS,paprop->a_next,FALSE);
			    paprop = (APROPTYPE *) vob;
			  }
			addr = addrStart + (long) mpgsndra[gsn];
			fprintf(bsLst," %05lxH",addr);
					/* Write start address */
			if(!papropSn->as_cbMx) cb = 0;
			else cb = papropSn->as_cbMx - 1;
			addr += (long) cb;
					/* Add seg len to address */
			fprintf(bsLst," %05lxH",addr);
					/* Write end address */
			fprintf(bsLst," %04xH  ",papropSn->as_cbMx);
					/* Write segment length */
			pahte = (AHTETYPE *) vob;
					/* Recast pointer */
			OutSb(bsLst,pahte->cch);
					/* Write segment name */
			if(B2W(pahte->cch[0]) > 22) cch = 1;
			else cch = 23 - B2W(pahte->cch[0]);
					/* Get number of spaces to emit */
			while(cch--) OutByte(bsLst,' ');
					/* Emit spaces */
			DEBUGVALUE(papropSn);
					/* Debug info */
			DEBUGVALUE(papropSn->as_rCla);
					/* Debug info */
			vob = ObGetVa(AREASYMS,papropSn->as_rCla,FALSE);
					/* Fetch class names from VM??? */
			pahte = (AHTETYPE *) vob;
					/* Recast pointer */
			OutSb(bsLst,pahte->cch);
					/* Output class name */
			NEWLINE(bsLst); /* Newline */
		      }
		  }
	      }
	  }
      }
    if(ggrMac != 1 || mpggrgsn[0] != SEGNIL)
      {
	NEWLINE(bsLst);                 /* Skip a line */
	fputs(" Origin   Group",bsLst); /* Header */
	NEWLINE(bsLst);                 /* Newline */
	EnSyms(PrintGroupOrigins,ATTRGRP);
					/* Apply function to symbols */
      }
    if(!vfMap)                          /* If publics not requested */
      {
	LEAVE(PrintMap,0xFFFE);         /* Debug info */
	return;                         /* Return */
      }
    DEBUGMSG("Printing publics by name...");
					/* Debug info */
    pubMac = 0;                         /* Initialize counter to zero */
    omppubrd = mppubrd;                 /* Put table address in global */
    EnSyms(SaveHtePublic,ATTRPNM);      /* Apply function to symbols */
    if(!pubMac)                         /* If no publics */
      {
	DEBUGMSG("No publics");         /* Debug info */
	LEAVE(PrintMap,0xFFFE);         /* Debug info */
	return;                         /* Return */
      }
    NEWLINE(bsLst);                     /* Skip a line */
    fputs("  Address         Publics by Name",bsLst);
					/* Header */
    NEWLINE(bsLst);                     /* Newline */
    NEWLINE(bsLst);                     /* Skip a line */
    fAddressSort = FALSE;               /* Sort lexicographically */
    Sort(mppubrd,pubMac);               /* Sort the publics */
    PrintSyms(mppubrd,pubMac);          /* Print them */
    DEBUGMSG("Printing publics by value...");
					/* Debug info */
    pubMac = 0;                         /* Initialize counter */
    NEWLINE(bsLst);                     /* Skip a line */
    fputs("  Address         Publics by Value",bsLst);
					/* Header */
    NEWLINE(bsLst);                     /* Newline */
    NEWLINE(bsLst);                     /* Skip a line */
    EnSyms(SavePropPublic,ATTRPNM);     /* Apply function to symbols */
    ASSERT(pubMac != 0);                /* Impossible for pubMac to be zero */
    fAddressSort = TRUE;                /* Sort by value */
    Sort(mppubrd,pubMac);               /* Sort the publics */
    PrintSyms(mppubrd,pubMac);          /* Print them */
    LEAVE(PrintMap,0xFFFF);             /* Debug info */
  }
